library ieee;
use ieee.std_logic_1164.all;

entity DEC3TO8 is
    port( SW0, SW1, SW2: in std_logic;
    LED0, LED1, LED2, LED3, LED4, LED5, LED6, LED7: out std_logic);
end DEC3TO8;

architecture RTL of DEC3TO8 is
    signal I: std_logic_vector( 2 downto 0 );
    signal O: std_logic_vector( 7 downto 0 );
begin
    I <= SW2 & SW1 & SW0;

    with I select
        O<= "11111110" when "000",
            "11111101" when "001",
            "11111011" when "010",
            "11110111" when "011",
            "11101111" when "100",
            "11011111" when "101",
            "10111111" when "110",
            "01111111" when "111",
            "11111111" when others;

    LED0<= O(0); LED1<= O(1); LED2<= O(2); LED3<= O(3); 
    LED4<= O(4); LED5<= O(5); LED6<= O(6); LED7<= O(7); 
end RTL;
