library ieee;
use ieee.std_logic_1164.all;

entity T_SEL4TO1 is
end T_SEL4TO1;

architecture SIM of T_SEL4TO1 is
  component SEL4TO1
    port( IN0, IN1, IN2, IN3 : in	std_logic;
          SEL : in  std_logic_vector(1 downto 0);
          DOUT :                   out 	std_logic);
  end component;

signal  A, B, C, D, Q: std_logic := '0';
signal  S: std_logic_vector(1 downto 0); 

begin
  U01:SEL4TO1 port map(IN0=>A, IN1=>B, IN2=>C, IN3=>D, SEL=>S, DOUT=>Q);

  CLKM: process begin
    wait for 100 ns; B <= not B; -- 5kHz
  end process;

  CLKH: process  begin
    wait for 50 ns;  C <= not C; -- 10kHz
  end process;

  CLKU: process  begin
    wait for 25 ns;  D <= not D; -- 20kHz
  end process;

  SELCLK: process  begin
    S <= "00";  wait for 100*4 ns;
    S <= "01";  wait for 100*4 ns;
    S <= "10";  wait for 100*4 ns;
    S <= "11";  wait for 100*4 ns;

    assert false;
    report "Simulation Complete!" severity Failure;	
  end process;
end SIM;