library ieee;
use ieee.std_logic_1164.all;

entity T_CHATTER is
end T_CHATTER;

architecture SIM of T_CHATTER is
  component CHATTER
  port( CLK, SWIN:   in   std_logic;
        SWOUT0:      out  std_logic;
        SWOUT1:      out  std_logic  );
  end component;
  signal CLK, SWIN:   std_logic;
  signal SWOUT0: std_logic :='1';
  signal SWOUT1: std_logic :='0';
begin
  U01:CHATTER port map( CLK, SWIN, SWOUT0, SWOUT1 );
  process begin
     CLK <= '0'; wait for 18 ns;
     CLK <= '1'; wait for 19 ns;
  end process;  
    
  process begin
    SWIN <= '1';
    wait for 50 us;
    for N in 1 to 16 loop
        SWIN <= '0' ; wait for 300 us; 
        SWIN <= '1' ; wait for 400 us; 
    end loop;
    SWIN <= '0'; wait for 10 ms;
    for N in 1 to 16 loop
        SWIN <= '1' ; wait for 400 us; 
        SWIN <= '0' ; wait for 300 us; 
    end loop;
    SWIN <= '1'; wait for 10 ms;

    assert false;
    report "Simulation Complete !!" severity Failure ;
  end process;
end SIM;
