library ieee;
use ieee.std_logic_1164.all;

entity T_CNT10ARUDLDSW is
end T_CNT10ARUDLDSW;

architecture SIM of T_CNT10ARUDLDSW is
  component CNT10ARUDLDSW
     port( SW0:   in   std_logic;  -- 入力信号
           SW1:   in   std_logic;  -- Up/Down
           SW2:   in   std_logic;  -- Load
           SW3:   in   std_logic;  -- RESET
           SW4:   in   std_logic_vector(3 downto 0); -- Load Input
           LED0, LED1, LED2, LED3:  out  std_logic );
  end component;
  signal SW0, SW3, LED0, LED1, LED2, LED3: std_logic:='0' ;
  signal SW1, SW2: std_logic:='1';
  signal SW4: std_logic_vector(3 downto 0):="0000";
begin
  U01:CNT10ARUDLDSW port map( SW0=>SW0, SW1=>SW1, SW2=>SW2, SW3=>SW3,
            SW4=>SW4, LED0=>LED0, LED1=>LED1, LED2=>LED2, LED3=>LED3 );

  SW3 <= '1' after  350 ns,   -- RESET
         '0' after  950 ns,
         '1' after 1350 ns,
         '0' after 3250 ns,
         '1' after 3350 ns;

  SW1 <= '0' after 2800 ns;   -- Up/Down

  SW2 <= '0' after 2100 ns,   -- Load
         '1' after 2300 ns,
         '0' after 4000 ns,
         '1' after 4200 ns;

  SW4 <= "0010" after 2000 ns,
         "0100" after 3000 ns;

  process begin
    for N in 1 to 25 loop     -- 入力信号
        SW0 <= '0' ; wait for 100 ns; 
        SW0 <= '1' ; wait for 100 ns; 
    end loop;

    assert false;
    report "Simulation Complete !!" severity Failure ;
  end process;
end SIM;
