library ieee;
use ieee.std_logic_1164.all;

entity T_TIMER is
end T_TIMER;

architecture SIM of T_TIMER is
    component TIMER
        generic( CYCLE: integer :=13500000);
        port( CLK:    in   std_logic;
              PULSE : out  std_logic );
    end component;

    signal CLK: std_logic;
    signal PULSE: std_logic:='0' ;

    begin
        U01:TIMER generic map( CYCLE => 5 )
                  port map( CLK=>CLK, PULSE=>PULSE);
    process begin
        for N in 1 to 20 loop
            CLK <= '0' ; wait for 18 us; 
            CLK <= '1' ; wait for 19 us; 
        end loop;

        assert false;
        report "Simulation Complete !!" severity Failure ;
    end process;
end SIM;
