library ieee;
use ieee.std_logic_1164.all;

entity T_TIMERLOAD is
end T_TIMERLOAD;

architecture SIM of T_TIMERLOAD is
    component TIMERLOAD
        generic( CYCLE: integer :=13500000);
        port( CLK:   in   std_logic;
              P500:  out  std_logic;
              LD:    in   std_logic;
              DATA:  in   integer range 0 to CYCLE-1 );
    end component;
        constant CYCLE: integer:= 13500000;
        constant PERIOD: Time:= 37 us;  -- 27MHz
        signal CLK:  std_logic:='0';
        signal P500: std_logic;
        signal DATA: integer range 0 to CYCLE;
        signal LD:   std_logic:='1';
begin
    U01:TIMERLOAD  generic map( CYCLE => 13500000)
                   port map( CLK=>CLK, P500=>P500, LD=>LD, DATA=>DATA );
    process begin
        CLK <= '0' ; wait for 18 ns; -- PERIOD/2; 
        CLK <= '1' ; wait for 19 ns; -- PERIOD/2; 
    end process;

    process begin
        DATA <= CYCLE-3; 
        wait for PERIOD/2;  -- ? 18 or 19
        wait for PERIOD*4;
        LD <= '0'; wait for PERIOD; LD <= '1';
        wait for PERIOD*5;

    assert false;
    report "Simulation Complete !!" severity Failure ;
  end process;
end SIM;
