library ieee;
 use ieee.std_logic_1164.all;

 entity COUNT10SWTOP is
    port( CLK, SW0, SW3: in   std_logic;
          SEG7LED0:      out  std_logic_vector( 7 downto 0 )  );

 end COUNT10SWTOP;

 architecture RTL of COUNT10SWTOP is
 component CHATTER is
    port( CLK, SWIN: in   std_logic;
          SWOUT0:    out  std_logic;
          SWOUT1:    out  std_logic  );
 end component;
 
 component COUNT10 is
    port( DIN, RST: in   std_logic;
          DOUT:     out  std_logic_vector( 3 downto 0 );
          CRY:      out  std_logic   );
 end component;

 component DISP7SEG is
    port( DECIN:      in   std_logic_vector( 3 downto 0 );
          DP:       in   std_logic;
          SEG7LED:  out  std_logic_vector( 7 downto 0 )  );
 end component;

 signal INPUT0, INPUT1, DPOFF:  std_logic;
 signal DECIMAL:       std_logic_vector( 3 downto 0 );
 begin
    DPOFF <= '1';
    U1: CHATTER port map( CLK=>CLK, SWOUT0=>INPUT0, SWOUT1=>open, SWIN=>SW0 );
    INPUT1 <= not INPUT0;
    U2: COUNT10 port map( INPUT1, SW3, DECIMAL, open );
    U3: DISP7SEG port map( DECIMAL, DPOFF, SEG7LED0);
 end RTL;
