library ieee;
use ieee.std_logic_1164.all;

entity DEC4CNTGEN is
  port( CLK, SW3: in  std_logic;
        SEG7LED0: out std_logic_vector(7 downto 0);
        SEG7LED1: out std_logic_vector(7 downto 0);
        SEG7LED2: out std_logic_vector(7 downto 0);
        SEG7LED3: out std_logic_vector(7 downto 0));
end DEC4CNTGEN;

architecture RTL of DEC4CNTGEN is
component T5MS is
   port( CLK:  in   std_logic;
         T5:   out  std_logic );
end component;

component COUNT10 is
    port( DIN, RST: in   std_logic;
          DOUT:     out  std_logic_vector( 3 downto 0 );
          CRY:      out  std_logic   );
end component;

component DISP7SEG is
    port( DECIN:    in   std_logic_vector( 3 downto 0 );
          DP:       in   std_logic;
          SEG7LED:  out  std_logic_vector( 7 downto 0 )  );
end component;

signal  T5: std_logic;
signal  DIN4: std_logic_vector( 15 downto 0 );
signal  CRY:  std_logic_vector(  2 downto 0 );
signal  SEG7: std_logic_vector( 31 downto 0 );
signal  DPOFF: std_logic;

begin
 DPOFF <= '0';
 SEG7LED0 <= SEG7(  7 downto  0 );
 SEG7LED1 <= SEG7( 15 downto  8 );
 SEG7LED2 <= SEG7( 23 downto 16 );
 SEG7LED3 <= SEG7( 31 downto 24 );

 U30:T5MS port map(CLK=>CLK, T5=>T5);
 
 GEN:for i in 0 to 3 generate
    FST:if(i=0) generate
        U00:COUNT10  port map(DIN=>T5, RST=>SW3,
                             DOUT=>DIN4((4*(i+1)-1) downto (4*i)), CRY=>CRY(i));
        U10:DISP7SEG port map(DECIN=>DIN4((4*(i+1)-1) downto (4*i)), DP=>DPOFF,
                             SEG7LED=>SEG7((8*(i+1)-1) downto (8*i)));
    end generate;

    MID:if(i/=0 and i/=3) generate
        U00:COUNT10  port map(DIN=>CRY(i-1), RST=>SW3,
                             DOUT=>DIN4((4*(i+1)-1) downto (4*i)), CRY=>CRY(i));
        U10:DISP7SEG port map(DECIN=>DIN4((4*(i+1)-1) downto (4*i)), DP=>DPOFF,
                             SEG7LED=>SEG7((8*(i+1)-1) downto (8*i)));
    end generate;

    LST:if(i=3) generate  
        U03:COUNT10  port map(DIN=>CRY(i-1), RST=>SW3,
                             DOUT=>DIN4((4*(i+1)-1) downto (4*i)), CRY=>open);
        U13:DISP7SEG port map(DECIN=>DIN4((4*(i+1)-1) downto (4*i)), DP=>DPOFF,
                             SEG7LED=>SEG7((8*(i+1)-1) downto (8*i)));
    end generate;
 end generate;
end RTL;
