library ieee;
use ieee.std_logic_1164.all;

library altera;
use altera.maxplus2.all;

entity DEC4CNTIP is
  port( CLK, SW3: in  std_logic;
        SEG7LED0: out std_logic_vector(7 downto 0);
        SEG7LED1: out std_logic_vector(7 downto 0);
        SEG7LED2: out std_logic_vector(7 downto 0);
        SEG7LED3: out std_logic_vector(7 downto 0));
end DEC4CNTIP;

architecture RTL of DEC4CNTIP is
component T5MS is
    port( CLK:  in   std_logic;
          T5:   out  std_logic );
end component;

signal  T5: std_logic;
signal  BIN40: std_logic_vector( 3 downto 0 );
signal  BIN41: std_logic_vector( 3 downto 0 );
signal  BIN42: std_logic_vector( 3 downto 0 );
signal  BIN43: std_logic_vector( 3 downto 0 );
signal  A0,B0,C0,D0,E0,F0,G0:  std_logic;
signal  A1,B1,C1,D1,E1,F1,G1:  std_logic;
signal  A2,B2,C2,D2,E2,F2,G2:  std_logic;
signal  A3,B3,C3,D3,E3,F3,G3:  std_logic;
signal  H,R,L,DPOFF:   std_logic;

begin
  R <= not SW3; L <= '0'; H <= '1'; DPOFF <= '1';

  U01:T5MS port map(CLK=>CLK, T5=>T5);

  U02:a_7490 port map(set9a=>L,set9b=>L,clra=>R,clrb=>R,
          clka=>T5,clkb=>BIN40(0),qd=>BIN40(3),
          qc=>BIN40(2),qb=>BIN40(1),qa=>BIN40(0));
  U03:a_7447 port map(ltn=>H,rbin=>H,d=>BIN40(3),c=>BIN40(2),
          b=>BIN40(1),a=>BIN40(0),bin=>H,oa=>A0,ob=>B0,oc=>C0,
          od=>D0,oe=>E0,a_of=>F0,og=>G0,rbon=>open );
  SEG7LED0 <= DPOFF & A0 & B0 & C0 & D0 & E0 & F0 & G0;
 
  U04:a_7490 port map(set9a=>L,set9b=>L,clra=>R,clrb=>R,
          clka=>BIN40(3),clkb=>BIN41(0),qd=>BIN41(3),
          qc=>BIN41(2),qb=>BIN41(1),qa=>BIN41(0));
  U05:a_7447 port map(ltn=>H,rbin=>H,d=>BIN41(3),c=>BIN41(2),
          b=>BIN41(1),a=>BIN41(0),bin=>H,oa=>A1,ob=>B1,oc=>C1,
          od=>D1,oe=>E1,a_of=>F1,og=>G1,rbon=>open );
  SEG7LED1 <= DPOFF & A1 & B1 & C1 & D1 & E1 & F1 & G1;
 
  U06:a_7490 port map(set9a=>L,set9b=>L,clra=>R,clrb=>R,
          clka=>BIN41(3),clkb=>BIN42(0),qd=>BIN42(3),
          qc=>BIN42(2),qb=>BIN42(1),qa=>BIN42(0));
  U07:a_7447 port map(ltn=>H,rbin=>H,d=>BIN42(3),c=>BIN42(2),
          b=>BIN42(1),a=>BIN42(0),bin=>H,oa=>A2,ob=>B2,oc=>C2,
          od=>D2,oe=>E2,a_of=>F2,og=>G2,rbon=>open );
  SEG7LED2 <= DPOFF & A2 & B2 & C2 & D2 & E2 & F2 &  G2;
 
  U08:a_7490 port map(set9a=>L,set9b=>L,clra=>R,clrb=>R,
          clka=>BIN42(3),clkb=>BIN43(0),qd=>BIN43(3),
          qc=>BIN43(2),qb=>BIN43(1),qa=>BIN43(0));
  U09:a_7447 port map(ltn=>H,rbin=>H,d=>BIN43(3),c=>BIN43(2),
          b=>BIN43(1),a=>BIN43(0),bin=>H,oa=>A3,ob=>B3,oc=>C3,
          od=>D3,oe=>E3,a_of=>F3,og=>G3,rbon=>open );
  SEG7LED3 <= DPOFF & A3 & B3 & C3 & D3 & E3 & F3 & G3;  
 end RTL;
