library ieee;
use ieee.std_logic_1164.all;

entity DEC4CNTTOP is
  port( CLK, SW3: in  std_logic;
        SEG7LED0: out std_logic_vector(7 downto 0);
        SEG7LED1: out std_logic_vector(7 downto 0);
        SEG7LED2: out std_logic_vector(7 downto 0);
        SEG7LED3: out std_logic_vector(7 downto 0));
end DEC4CNTTOP;

architecture RTL of DEC4CNTTOP is
component T5MS is
    port( CLK:  in   std_logic;
          T5:   out  std_logic );
end component;

component COUNT10 is
    port( DIN, RST: in   std_logic;
          DOUT:     out  std_logic_vector( 3 downto 0 );
          CRY:      out  std_logic   );
end component;

component DISP7SEG is
    port( DECIN:    in   std_logic_vector( 3 downto 0 );
          DP:       in   std_logic;
          SEG7LED:  out  std_logic_vector( 7 downto 0 )  );
end component;

signal  T5: std_logic;
signal  BIN40, BIN41, BIN42, BIN43: std_logic_vector( 3 downto 0 );
signal  DPOFF, CRY0, CRY1, CRY2:  std_logic;

begin
  DPOFF <= '0';
  U01:T5MS port map(CLK=>CLK, T5=>T5);
  U02:COUNT10  port map(DIN=>T5,   RST=>SW3, DOUT=>BIN40, CRY=>CRY0);
  U03:DISP7SEG port map(DECIN=>BIN40, DP=>DPOFF, SEG7LED=>SEG7LED0);
  U04:COUNT10  port map(DIN=>CRY0, RST=>SW3, DOUT=>BIN41, CRY=>CRY1);
  U05:DISP7SEG port map(DECIN=>BIN41, DP=>DPOFF, SEG7LED=>SEG7LED1);
  U06:COUNT10  port map(DIN=>CRY1, RST=>SW3, DOUT=>BIN42, CRY=>CRY2);
  U07:DISP7SEG port map(DECIN=>BIN42, DP=>DPOFF, SEG7LED=>SEG7LED2);
  U08:COUNT10  port map(DIN=>CRY2, RST=>SW3, DOUT=>BIN43, CRY=>open);
  U09:DISP7SEG port map(DECIN=>BIN43, DP=>DPOFF, SEG7LED=>SEG7LED3);
end RTL;
