library ieee;
use ieee.std_logic_1164.all;

entity STATE0 is
    port(   CLK, SW3:  in    std_logic; --RESET = SW3
            SW1:       in    std_logic;
            SEG7LED0:  out   std_logic_vector( 6 downto 0 ));
end STATE0;

architecture RTL of STATE0 is
component CHATTER is
    port(   CLK, SWIN:   in   std_logic;
            SWOUT0:      out  std_logic;
            SWOUT1:      out  std_logic  );
end component;

type   STATE_TYPE is   ( S1, S2, S3 );
signal  MY_STATE: STATE_TYPE;

signal SSW:  std_logic;

begin
U01: CHATTER port map( CLK=>CLK, SWIN=>SW1, SWOUT0=>SSW, SWOUT1=>open );

    STATE_MACHINE: process( SW3, SSW ) begin
        if( SW3='0' ) then MY_STATE <= S1;
        elsif( SSW'event and SSW='0' ) then
            case MY_STATE is
                when S1 => MY_STATE <= S2;
                when S2 => MY_STATE <= S3;
                when S3 => MY_STATE <= S1;
            end case;
        end if;
    end process;

    ACTION: process( MY_STATE ) begin
        case MY_STATE is
            when S1 => SEG7LED0 <= "1001111";  --1
            when S2 => SEG7LED0 <= "0010010";  --2
            when S3 => SEG7LED0 <= "0000110";  --3
        end case;
    end process;
end RTL;
