library ieee;
use ieee.std_logic_1164.all;

entity STATE2 is
    port(   CLK, SW3:  in    std_logic;  --RESET = SW3
            SW1, SW2:  in    std_logic;
            SEG7LED1:  out   std_logic_vector( 6 downto 0 );
            SEG7LED2:  out   std_logic_vector( 6 downto 0 );
            SEG7LED3:  out   std_logic_vector( 6 downto 0 ));
end STATE2;

architecture RTL of STATE2 is
component CHATTER is
    port( CLK, SWIN: in   std_logic;
          SWOUT0:    out  std_logic;
          SWOUT1:    out  std_logic  );
end component;

type   STATE_TYPE is   ( S1, S2, S3 );
signal MY_STATE:        STATE_TYPE;

signal SW12, SSW:  std_logic;

begin
SW12 <= SW1 and SW2;
U01: CHATTER port map( CLK=>CLK, SWIN=>SW12, SWOUT0=>SSW, SWOUT1=>open );

   STATE_MACHINE: process( SW3, SSW ) begin
        if( SW3='0' ) then  MY_STATE <= S1;
        elsif( SSW'event and SSW='0' ) then
            case MY_STATE is
                when S1 =>
                    if   ( SW1 = '0' ) then MY_STATE <= S2;
                    elsif( SW2 = '0' ) then MY_STATE <= S3;
                    end if;
                when S2 =>
                    if   ( SW1 = '0' ) then MY_STATE <= S3;
                    elsif( SW2 = '0' ) then MY_STATE <= S1;
                    end if;
                when S3 =>
                    if   ( SW1 = '0' ) then MY_STATE <= S1;
                    elsif( SW2 = '0' ) then MY_STATE <= S2;
                    end if;
            end case;
        end if;
    end process;


	 
S1_STATE: process(MY_STATE)
begin
    if( MY_STATE=S1 ) then SEG7LED1 <= "1001111";  --1
                      else SEG7LED1 <= "1111110";  ---
    end if;
end process; 

S2_STATE: process(MY_STATE)
begin
    if( MY_STATE=S2 ) then SEG7LED2 <= "0010010";  --2
                      else SEG7LED2 <= "1111110";  ---
    end if;
end process; 

S3_STATE: process(MY_STATE)
begin
    if( MY_STATE=S3 ) then SEG7LED3 <= "0000110";  --3
                      else SEG7LED3 <= "1111110";  ---
    end if;
end process; 
end RTL;