library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity CNT10ARUDTX is
    generic (MODE : string(1 to 3) := "RTL");
    port( SW0:   in   std_logic;  --入力信号
          SW1:   in   std_logic;  -- Up/Down
          SW3:   in   std_logic;  -- RESET
          LED0, LED1, LED2, LED3:  out  std_logic );
end CNT10ARUDTX;

architecture RTL of CNT10ARUDTX is
signal OPE : string(1 to 3);
signal CNT: std_logic_vector( 3 downto 0 ):="0000";

begin
    LED0<=CNT(0); LED1<=CNT(1); LED2<=CNT(2); LED3<=CNT(3);
    process( SW0, SW3 ) begin
        if( SW3='0' ) then CNT <= "0000";  -- RESET
        elsif( SW0'event and SW0='0') then 
            if( SW1='1') then              -- Up
               if( CNT="1001" ) then CNT <="0000"; --10進
               else                  CNT <= CNT + 1;
               end if;
            else                           -- Down
            if( CNT="0000" ) then CNT <= "1001";   --10進
	    else                  CNT <= CNT - 1;
            end if;
        end if;
    end if;
    end process;

    TEXT: if MODE = "SIM" generate
        process (SW1) begin
           if (SW1 = '0') then OPE <= "INC";
           else                OPE <= "DEC";
           end if;
        end process;
    end generate;

end RTL;

