library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity CNT16ARUD is
    port( SW0:   in   std_logic;
          SW1:   in   std_logic;  -- Up/Down
          SW3:   in   std_logic;  -- RESET
          LED0, LED1, LED2, LED3:  out  std_logic );
end CNT16ARUD;

architecture RTL of CNT16ARUD is
signal CNT: std_logic_vector( 3 downto 0 ):="0000";

begin
    LED0<=CNT(0); LED1<=CNT(1); LED2<=CNT(2); LED3<=CNT(3);

    process( SW0, SW3 ) begin
        if( SW3='0' ) then CNT <= "0000";     -- RESET
        elsif( SW0'event and SW0='0') then 
            if( SW1='1') then CNT <= CNT + 1; -- Up
            else              CNT <= CNT - 1; -- Down
            end if;
        end if;
    end process;
end RTL;
