library ieee;
use ieee.std_logic_1164.all;

library altera;
use altera.maxplus2.all;

entity NF4 is
    port( CLK: in  std_logic;
          LED0, LED1, LED2, LED3, LED4,
          LED5, LED6, LED7:  out   std_logic );
end NF4;

architecture RTL of NF4 is

component TIMER is
    generic( CYCLE: integer :=13500000); -- default 0.5s
    port( CLK:    in   std_logic;
          PULSE : out  std_logic );
end component;

signal  TOUT:            std_logic;
signal  QA, QB, QC, QD:  std_logic;
signal  QQA, QQB, QQC:   std_logic;
signal  H, L:            std_logic;
signal  Y0, Y1, Y2, Y3, Y4, Y5, Y6, Y7: std_logic;

begin
    H <= '1';  L <= '0';
    U01: TIMER generic map( CYCLE=>6000000 )
               port map( CLK=>CLK, PULSE=>TOUT );
    U02: a_7493 port map( TOUT, QA, L, L, QD, QC, QB, QA );
    U03: a_7486 port map( QA, QD, QQA );
    U04: a_7486 port map( QB, QD, QQB );
    U05: a_7486 port map( QC, QD, QQC );
    U06: a_74138 port map(H, L, L, QQC, QQB, QQA,
                          Y0, Y1, Y2, Y3, Y4, Y5, Y6, Y7 );
    LED0 <= not Y0; LED1 <= not Y1; LED2 <= not Y2; LED3 <= not Y3;
    LED4 <= not Y4; LED5 <= not Y5; LED6 <= not Y6; LED7 <= not Y7;
end RTL;


【参考】Maxplus2中にあるコンポーネント宣言の抜粋
-- component a_7493
--	port (	clka: in STD_LOGIC;
--		clkb: in STD_LOGIC;
--		ro1: in STD_LOGIC;
--		ro2: in STD_LOGIC;
--		qd: out STD_LOGIC;
--		qc: out STD_LOGIC;
--		qb: out STD_LOGIC;
--		qa: out STD_LOGIC);
-- end component;

-- component a_7486
--	port (	a_2: in STD_LOGIC;
--		a_3: in STD_LOGIC;
--		a_1: out STD_LOGIC);
-- end component;

-- component a_74138
--	port (	g1: in STD_LOGIC;
--		g2an: in STD_LOGIC;
--		g2bn: in STD_LOGIC;
--		c: in STD_LOGIC;
--		b: in STD_LOGIC;
--		a: in STD_LOGIC;
--		y0n: out STD_LOGIC;
--		y1n: out STD_LOGIC;
--		y2n: out STD_LOGIC;
--		y3n: out STD_LOGIC;
--		y4n: out STD_LOGIC;
--		y5n: out STD_LOGIC;
--		y6n: out STD_LOGIC;
--		y7n: out STD_LOGIC);
-- end component;
