library ieee;
use ieee.std_logic_1164.all;

entity NF45 is
    generic( MODE: string(1 to 3):= "RTL");
    port( CLK: in  std_logic;
          LED0, LED1, LED2, LED3, LED4,
          LED5, LED6, LED7:  out   std_logic );
end NF45;

architecture RTL of NF45 is

component TIMER is
    generic( CYCLE: integer :=13500000);
    port( CLK:    in   std_logic;
          PULSE : out  std_logic );
end component;

component BIN4 is
     port( SW0:   in   std_logic;
           LED0, LED1, LED2, LED3:  out  std_logic );
end component;

component DEC3TO8 is
    port( SW0, SW1, SW2: in std_logic;
    LED0, LED1, LED2, LED3, LED4, LED5, LED6, LED7: out std_logic);
end component;

signal  TOUT:            std_logic;
signal  QA, QB, QC, QD:  std_logic;
signal  QQA, QQB, QQC:   std_logic;
signal  H, L:            std_logic;
signal  Y0, Y1, Y2, Y3, Y4, Y5, Y6, Y7: std_logic;

begin

TM0: if MODE = "RTL" generate
U01: TIMER generic map( CYCLE=>6750000 )  -- set 250 ms
           port map( CLK=>CLK, PULSE=>TOUT );
end generate;

TM1: if MODE = "SIM" generate
U01: TIMER generic map( CYCLE=>6750000 )  -- set 250 ms
           port map( CLK=>CLK, PULSE=>open );
     TOUT <= CLK;
end generate;

U02: BIN4 port map( TOUT, QA, QB, QC, QD );

    QQA <= QA xor QD;  -- U03: a_7486 port map( QA, QD, QQA );
    QQB <= QB xor QD;  -- U04: a_7486 port map( QB, QD, QQB );
    QQC <= QC xor QD;  -- U05: a_7486 port map( QC, QD, QQC );
	 
U06: DEC3TO8 port map(QQA, QQB, QQC, Y0, Y1, Y2, Y3, Y4, Y5, Y6, Y7 );

    LED0 <= not Y0; LED1 <= not Y1; LED2 <= not Y2; LED3 <= not Y3;
    LED4 <= not Y4; LED5 <= not Y5; LED6 <= not Y6; LED7 <= not Y7;
	 
end RTL;
