library IEEE;
use std.textio.all;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_textio.all;

entity T_7SEGLED is
end T_7SEGLED;

architecture SIM of T_7SEGLED is
component DEC7LED is
    port( SW4 :      in   std_logic_vector(3 downto 0 );
          SEG7LED0 : out  std_logic_vector(6 downto 0 ));
end component ;

constant PERIOD: time := 100 ns;
signal INSEG:  std_logic_vector(6 downto 0) ;
signal RDSEG:  std_logic_vector(6 downto 0) ;
signal NUMDAT: std_logic_vector(3 downto 0) ;   

begin
TEST: DEC7LED port map( SW4 => NUMDAT, SEG7LED0 => INSEG );

    process
    file DATFILE: text open read_mode is "TEST.DAT";
    variable BUF: line;
    variable DEC: std_logic_vector(3 downto 0);
    variable TDAT:std_logic_vector(7 downto 0);
    begin    
        assert not (endfile (DATFILE))
        report "Simulation Complete !!"
        severity Failure ;

        readline(DATFILE,BUF);
        read(BUF,DEC);
        read(BUF,TDAT);
        NUMDAT <= DEC;
        RDSEG  <= TDAT(6 downto 0);
        wait for PERIOD;
    end process;
    
    process begin
        wait for PERIOD/2;
        assert RDSEG = INSEG
        report "DATA Mismatch!! :"
             & " NUMDAT=" & std_logic'IMAGE(NUMDAT(3))
                          & std_logic'IMAGE(NUMDAT(2))
                          & std_logic'IMAGE(NUMDAT(1))
                          & std_logic'IMAGE(NUMDAT(0))
             & " INSEG="  & std_logic'IMAGE(INSEG(6))
                          & std_logic'IMAGE(INSEG(5))
                          & std_logic'IMAGE(INSEG(4))
                          & std_logic'IMAGE(INSEG(3))
                          & std_logic'IMAGE(INSEG(2))
                          & std_logic'IMAGE(INSEG(1))
                          & std_logic'IMAGE(INSEG(0))
              & " RDSEG=" & std_logic'IMAGE(RDSEG(6))
                          & std_logic'IMAGE(RDSEG(5))
                          & std_logic'IMAGE(RDSEG(4))
                          & std_logic'IMAGE(RDSEG(3))
                          & std_logic'IMAGE(RDSEG(2))
                          & std_logic'IMAGE(RDSEG(1))
                          & std_logic'IMAGE(RDSEG(0))
        severity Warning ;
        wait for PERIOD/2;
    end process;
end SIM;
