library IEEE;
use std.textio.all;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_textio.all;

entity T_FWRITE is
end T_FWRITE;

architecture SIM of T_FWRITE is
component DISP7SEG is
    port( DECIN:    in   std_logic_vector( 3 downto 0 );
          DP:       in   std_logic;
          SEG7LED:  out  std_logic_vector( 7 downto 0 )  );
end component ;

constant PERIOD: time := 20 ns;

signal SEG7: std_logic_vector(7 downto 0) ;
signal DEC:  std_logic_vector(3 downto 0) ;
signal L: std_logic:='0';

begin
U00: DISP7SEG port map( DECIN => DEC, DP=>L,SEG7LED=>SEG7 );

process begin
   for i in 0 to 9 loop
      DEC <= conv_std_logic_vector(i,4);
      wait for PERIOD;
   end loop;

   assert false
   report "Simulation Complete!!"
   severity Failure;
end process;

process
file DATFILE: text open write_mode is "TEST.DAT";
variable BUF: line;
begin    
   wait for PERIOD/2;
   write(BUF,DEC);
   write(BUF,string'("  "));
   write(BUF,SEG7);
   writeline(DATFILE,BUF);
   wait for PERIOD/2;
end process;
end SIM;
