library IEEE;
use std.textio.all;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_textio.all;

entity T_NF11 is
end T_NF11;

architecture SIM of T_NF11 is
component NF11 is
    generic( MODE: string(1 to 3):= "RTL");
    port( CLK:  in   std_logic;
          LED0, LED1, LED2, LED3,
          LED4, LED5, LED6, LED7: out  std_logic );
end component ;

constant PERIOD: time := 250 ms;
signal CLK:  std_logic:='1';
signal NUM:  std_logic_vector(3 downto 0);
signal LEDS: std_logic_vector(7 downto 0);

begin
U11: NF11 generic map( MODE => "SIM" ) 
          port map( CLK=>CLK, LED0=>LEDS(0), LED1=>LEDS(1),
                    LED2=>LEDS(2), LED3=>LEDS(3), LED4=>LEDS(4),
                    LED5=>LEDS(5), LED6=>LEDS(6), LED7=>LEDS(7) );
process
   file DATFILE: TEXT open write_mode is "NF_LEDS.DAT";
   variable BUF: LINE;
begin
   for i in 0 to 25 loop
      NUM <= conv_std_logic_vector(i,4);
      wait for PERIOD/2; CLK <= '1'; 

      write(BUF,NUM);
      write(BUF,string'("  "));
      write(BUF,LEDS);
      writeline(DATFILE,BUF);

      wait for PERIOD/2; CLK <= '0';
   end loop;

   assert false
   report "Simulation Complete!!"
   severity Failure;
end process;
end SIM;
