library IEEE;
use std.textio.all;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_textio.all;

entity T_NFFILE is
end T_NFFILE;

architecture SIM of T_NFFILE is
component NF11 is
    generic( MODE: string(1 to 3):= "RTL");
    port( CLK:	in	std_logic;
          LED0, LED1, LED2, LED3,
          LED4, LED5, LED6, LED7: out  std_logic );
end component ;

constant PERIOD: time := 250 ms;
signal CLK:       std_logic:='1';
signal LEDS:      std_logic_vector(7 downto 0) ;
signal LEDS_FILE: std_logic_vector(7 downto 0) ;
signal NUM:       std_logic_vector(3 downto 0) ;

begin
U11: NF11 generic map( MODE => "SIM" ) 
          port map( CLK=>CLK, LED0=>LEDS(0), LED1=>LEDS(1),
                    LED2=>LEDS(2), LED3=>LEDS(3), LED4=>LEDS(4),
                    LED5=>LEDS(5), LED6=>LEDS(6), LED7=>LEDS(7) );
   process
        file testvectors: TEXT open read_mode is "NF_LEDS.DAT";
        variable RBUF:          line;
        variable NUM_VAL:       std_logic_vector(3 downto 0);
        variable LEDS_FILE_VAL: std_logic_vector(7 downto 0);
    begin    
        for i in 0 to 25 loop
            readline(testvectors,RBUF);
            read(RBUF,NUM_VAL);
            read(RBUF,LEDS_FILE_VAL);
            NUM <= NUM_VAL;
            LEDS_FILE <= LEDS_FILE_VAL;
  
            wait for PERIOD/2; CLK <= '1';

            assert LEDS = LEDS_FILE
            report "DATA MISMATCH!! :" & std_logic'IMAGE(NUM(3))
                                       & std_logic'IMAGE(NUM(2))
                                       & std_logic'IMAGE(NUM(1))
                                       & std_logic'IMAGE(NUM(0))
                 & "   LEDS=" & std_logic'IMAGE(LEDS(7))
                              & std_logic'IMAGE(LEDS(6))
                              & std_logic'IMAGE(LEDS(5))
                              & std_logic'IMAGE(LEDS(4))
                              & std_logic'IMAGE(LEDS(3))
                              & std_logic'IMAGE(LEDS(2))
                              & std_logic'IMAGE(LEDS(1))
                              & std_logic'IMAGE(LEDS(0))
                 & "   FILE=" & std_logic'IMAGE(LEDS_FILE(7))
                              & std_logic'IMAGE(LEDS_FILE(6))
                              & std_logic'IMAGE(LEDS_FILE(5))
                              & std_logic'IMAGE(LEDS_FILE(4))
                              & std_logic'IMAGE(LEDS_FILE(3))
                              & std_logic'IMAGE(LEDS_FILE(2))
                              & std_logic'IMAGE(LEDS_FILE(1))
                              & std_logic'IMAGE(LEDS_FILE(0))
            severity Warning ;

            wait for PERIOD/2; CLK <= '0';
        end loop;

    assert false
    report "Simulation Complete!!"
    severity Failure;
end process;
end SIM;
