library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity DEMO_LENGTH is
    port( CLK:   in  std_logic;
          LED0:  out std_logic );  
end DEMO_LENGTH;

architecture RTL of DEMO_LENGTH is
component LENGTH 
port( CLK:   in  std_logic;
      LD:    in  std_logic;
      DATA:  in  std_logic_vector(3 downto 0);
      RESET: in  std_logic;
      TEMPO: out std_logic );
end component;

component TOGGLE
    port( SW0:   in   std_logic;
          LED0:  out  std_logic );
end component;

signal DATA: std_logic_vector( 3 downto 0 );
signal H, LD, TEMPO: std_logic;

begin
H<='1'; DATA<="0100";
U01: LENGTH port map( CLK=>CLK, LD=>LD, DATA=>DATA, RESET=> LD, TEMPO=>TEMPO );
U02: TOGGLE port map( SW0=>TEMPO, LED0=>LED0 );

   process( CLK, TEMPO )  begin
       if( TEMPO='0' )               then LD<='0';
       elsif( CLK'event and CLK='0') then LD<='1';
       end if;
   end process;
end RTL;
