library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity DEMO_SOUND is
    port( CLK:   in  std_logic;
          RESET: in  std_logic;
          LED0:  out std_logic;
          LED1:  out std_logic;
          SP:    out std_logic  );  
end DEMO_SOUND;

architecture RTL of DEMO_SOUND is
component SOUND 
port( CLK:      in  std_logic;
      INTERVAL: in  integer range 0 to 25813;
      LD:       in  std_logic;
      RESET:    in  std_logic;
      SP:       out std_logic );
end component;

type ROMARRAY is array(0 to 7) of integer range 0 to 25813;
constant SCORE: ROMARRAY := ( 12907, 11499, 10243, 9671, 8610, 7670, 6832, 6453 );
signal POINT:    integer range 0 to 7;
signal CNT:      integer range 0 to 13500000; -- 0.5 sec
signal INTERVAL: integer range 0 to 25813;
signal LD: std_logic; 

begin
U01: SOUND port map( CLK=>CLK, INTERVAL=>INTERVAL, LD=>LD, RESET=>RESET, SP=>SP );

INTERVAL <= SCORE( POINT );
    process( CLK, RESET ) begin
        if(RESET = '0' ) then POINT <= 0; CNT <= 0; LD <= '1';
        elsif( CLK'event and CLK='0') then 
            if ( CNT = 13499999 ) then POINT <= POINT + 1; LD <= '0'; CNT <=0;
            else    CNT <= CNT+1; LD <= '1';
            end if;
        end if;
    end process;
end RTL;
