library ieee;
use ieee.std_logic_1164.all;

entity LENGTH is
port( CLK:   in  std_logic;
      LD:    in  std_logic;
      DATA:  in  std_logic_vector(3 downto 0);
      RESET: in  std_logic;
      TEMPO: out std_logic );
end LENGTH;

architecture RTL of LENGTH is

component DEV
    generic( CYCLE: integer :=13500000);  -- 0.5S at 27MHz
    port( CLK:   in   std_logic;
          PULSE: out  std_logic;
          RESET: in   std_logic );
end component;

component DCOUNT
port( CLK:   in  std_logic;
      PLS:   out std_logic;
      LD:    in  std_logic;
      DATA:  in  std_logic_vector(3 downto 0) );
end component;

signal PULSE: std_logic;
begin
    U01: DEV generic map( CYCLE=>4500000 )
             port map( CLK=>CLK, PULSE=>PULSE, RESET=>RESET );

    U02: DCOUNT port map( CLK=>PULSE, PLS=>TEMPO,
	                        LD=>LD, DATA=>DATA );
end RTL;
