library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity RAM8X32 is
    port( ADDR    : in  std_logic_vector(4 downto 0);
          DIN     : in  std_logic_vector(7 downto 0);
          DOUT    : out std_logic_vector(7 downto 0);
          RW      : in  std_logic;       --1:read, 0:write
          EN      : in  std_logic );
end RAM8X32;

architecture RTL of RAM8X32 is
type RAM_TYPE is array (0 to 31) of std_logic_vector(7 downto 0);
signal RAMBODY : RAM_TYPE;
signal ADR : integer range 0 to 31;

begin
    ADR <= conv_integer( ADDR );

    process( EN )
    begin
        if( EN'event and EN='1') then
           	if(RW='1') then DOUT <= RAMBODY( ADR );
            else            RAMBODY( ADR ) <= DIN;
           	end if;
        end if;
    end process;
end;
