library ieee;
use ieee.std_logic_1164.all;

entity SOUND is
port( CLK:      in  std_logic;
      INTERVAL: in  integer range 0 to 25813; -- ontei
      LD:       in  std_logic;
      RESET:    in  std_logic;
      SP:       out std_logic );
end SOUND;

architecture RTL of SOUND is
component TIMER2
    generic( CYCLE: integer :=13500000 ); -- 0.5s at 27MHz
    port( CLK:   in   std_logic;
          RESET: in   std_logic;
          POUT:  out  std_logic;
          LD:    in   std_logic;
          DATA:  in   integer range 0 to CYCLE-1 );
end component;

component TOGGLE
     port( SW0:   in   std_logic;
           LED0:  out  std_logic );
end component;

signal POUT: std_logic;

begin
U01: TIMER2 generic map(  CYCLE=>25813 )
            port map( CLK=>CLK, RESET=>RESET,
                      POUT=>POUT, LD=>LD, DATA=>INTERVAL );

U02: TOGGLE port map( SW0=>POUT, LED0=>SP );

end RTL;
