library ieee;
use ieee.std_logic_1164.all;

entity TIMER2 is
    generic( CYCLE: integer :=13500000); -- 0.5s at 27MHz
    port( CLK:   in   std_logic;
          RESET: in   std_logic;
          POUT:  out  std_logic;
          LD:    in   std_logic;
          DATA:  in   integer range 0 to CYCLE-1 );
end TIMER2;

architecture RTL of TIMER2 is
signal CNT: integer range 0 to CYCLE-1:=0;

begin
    process( CLK, RESET, LD ) begin
        if( RESET = '0' ) then CNT <= 0;
        elsif( LD = '0' ) then CNT <= DATA;
        elsif( CLK'event and CLK='0') then 
            if CNT=0 then CNT <= DATA;  POUT <= '1';
            else          CNT <= CNT-1; POUT <= '0';
            end if;
        end if;
    end process;
end RTL;
