library ieee;
use ieee.std_logic_1164.all;

entity T_DCOUNT is
end T_DCOUNT;

architecture RTL of T_DCOUNT is

component DCOUNT
port( CLK:   in  std_logic;
      PLS:   out std_logic;
      LD:    in  std_logic;
      DATA:  in  std_logic_vector(3 downto 0) );
end component;

signal CLK, LD: std_logic;
signal PLS: std_logic:='0';
signal DATA:  std_logic_vector(3 downto 0);
constant PERIOD: TIME:= 167 ms; -- 1/6 sec
constant CLOCK:  TIME:=  37 ns; -- 1/27 MHz

begin
U01:DCOUNT port map( CLK=>CLK, PLS=>PLS, LD=>LD, DATA=>DATA );

   process begin
       CLK <= '0'; wait for PERIOD/2;
       CLK <= '1'; wait for PERIOD/2;
   end process;

   process begin
       DATA <= "0010"; LD <= '0'; wait for CLOCK;
       LD <= '1'; wait for PERIOD*10;

       DATA <= "0100"; LD <= '0'; wait for CLOCK;
       LD <= '1'; wait for PERIOD*10;

       DATA <= "0110"; LD <= '0'; wait for CLOCK;
       LD <= '1'; wait for PERIOD*10;

       DATA <= "1000"; LD <= '0'; wait for CLOCK;
       LD <= '1'; wait for PERIOD*10;

       assert false;
       report "Simulation Complete !!" severity Failure ;
   end process;
end RTL;
