library ieee;
use ieee.std_logic_1164.all;

entity T_SOUND is
end T_SOUND;

architecture RTL of T_SOUND is
component SOUND
port( CLK:      in  std_logic;
      INTERVAL: in  integer range 0 to 25813; -- ontei
      LD:       in  std_logic;
      RESET:    in  std_logic;
      SP:       out std_logic );
end component;

signal CLK, LD, RESET, SP: std_logic;
signal INTERVAL:  integer  range 0 to 25813;
constant PERIOD:  TIME:= 37 ns; -- 1/27MHz

begin
U01:SOUND port map( CLK=>CLK, INTERVAL=>INTERVAL,
                    LD=>LD, RESET=>RESET, SP=>SP );

    process	begin
        CLK <= '0'; wait for PERIOD/2;
        CLK <= '1'; wait for PERIOD/2;
    end process;

    process  begin
        RESET <= '0'; LD <= '1';  wait for PERIOD/2;
        RESET <= '1';             wait for PERIOD;
        INTERVAL <= 3; LD <= '0'; wait for PERIOD;
        LD <= '1';                wait for PERIOD*20;
        INTERVAL <= 5; LD <= '0'; wait for PERIOD;
        LD <= '1';                wait for PERIOD*20;

        assert false;
        report "Simulation Complete !!"
        severity Failure ;
    end process;
end RTL;
